local L = LibStub("AceLocale-3.0"):GetLocale("NeedjaTracker", true);

function NeedjaTracker:RollAllPassed(args)
    local db = self.db.char;
    self:AddRollHistory({ item = args.item, choice = "pass" });
    db.RollResults[args.item] = nil;
    PrintToChat((L.msg_pass_party):format(args.item));
end

function NeedjaTracker:RollChose(args)
    local db = self.db.char;
    local res = GetCreateField(db.RollResults, args.item, args.player);
    res.choice = args.choice;
    if args.choice == "need" and args.player ~= UnitName("player") then
        PrintToChat((L.msg_roll_need):format(args.item, args.player, L["roll_" .. (args.choice or 'unknown')]));
    end
end

function NeedjaTracker:RollRolled(args)
    local db = self.db.char;
    local res = GetCreateField(db.RollResults, args.item, args.player);
    res.roll   = args.roll;
    res.choice = args.choice;
    self:AddRollStatistics({ player = args.player, choice = args.choice });
end

function NeedjaTracker:RollWon(args)
    local db = self.db.char;
    local res = GetCreateField(db.RollResults, args.item, args.player);
    self:AddRollHistory({ item = args.item, player = args.player, choice = res.choice, roll = res.roll });
    self:AddRollStatistics({ player = args.player, choice = "win" })
    db.RollResults[args.item] = nil;
    if args.player == UnitName("player") then
        PrintToChat((L.msg_win_you):format(args.item, L["roll_" .. (res.choice or 'unknown')], (res.roll or '?')));
    elseif args.choice == "need" then
        PrintToChat((L.msg_win_party_need):format(args.item, args.player, L["roll_" .. (res.choice or 'unknown')], (res.roll or '?')));
    else
        PrintToChat((L.msg_win_party):format(args.item, args.player, L["roll_" .. (res.choice or 'unknown')], (res.roll or '?')));
    end
end

function NeedjaTracker:RollWonNoSpam(args)
    self:RollRolled(args);
    self:RollWon(args);
end

function NeedjaTracker:ClearRollHistory()
    local db = self.db.char;
    db.RollHistory = {};
    db.RollStatistics = {};
end

function NeedjaTracker:AddRollHistory(args)
    local db = self.db.char;
    table.insert(db.RollHistory, args);
    if # db.RollHistory > 20 then
        table.remove(db.RollHistory, 1);
    end
end

function NeedjaTracker:AddRollStatistics(args)
    local db = self.db.char;
    local pos, n, stat;
    for n, stat in pairs(db.RollStatistics) do
        if stat.player == args.player then
            stat[args.choice] = (stat[args.choice] or 0) + 1;
            return;
        end
    end
    table.insert(db.RollStatistics, { player = args.player, [args.choice] = 1 });
end
